/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : name_wb.c
Last edit : 10/20/92
Created   :
Version   : 1.9

History   : A new file for v6.0

Does      : Creates a random name. 
	    char *do_name()
*/

#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <strings.h>
#include <stdlib.h>
#include <curses.h>
#include <mform.h>

#include <paths.h>
#include <limits.h>

#include "name_main.h"

extern char	*mstrtok(char *, char *);
extern char	*create_name();

char *do_name(void)
{
  struct name_main 	nimi={""};
  int 			ok=0;
  int 			m=0;
  int 			i=0;
  char 			*directory=NULL;
  char 			*dirri=NULL;
  char 			*name=NULL;
  char 			*t=NULL;
  int 			len=0;
  FILE 			*dst=NULL;
  
  siemen();			/* A random random seed. */
  clear();
  put_name_main(&nimi);		/* Put menu. */

  while(!ok) {			/* Until satisfied. */
    move(8,21);
    refresh();
    m = getch();
    m = isupper(m) ? tolower(m) : m;	
    switch(m) {
      case 'r':			/* Roll for a name. */
	sprintf(nimi.nimi,"%s",create_name());
	put_name_main(&nimi);	/* Refresh screen. */
	break;
      case 'a':			/* Accept name. */
	if(!nimi.nimi[0])	/* No name to accept! */
	  break;
        directory = mstrtok(nimi.nimi," \t\n");
	if(!directory) {
	  move(22,0);
	  clrtoeol();
	  move(22,0);
	  printw("Illegal name! Press any key to continue!");
	  refresh();
	  getch();
	  move(22,0);
	  clrtoeol();
	  break;
        }
        len = strlen(directory) + strlen(SAVE) + 2;
        dirri = malloc(len);
        if(!dirri) {
          perror("st_wb.cc/malloc()");
          exit(0);
        }
        len = strlen(directory) + 14 + 5;
        name = malloc(len);
        if(!name) {
          perror("name_wb.cc/malloc()");
          exit(0);
        }
        sprintf(name,"%s.name",directory);
        sprintf(dirri,"%s/%s",SAVE,directory);    
	if(chdir(dirri)) {
	  if(mkdir(dirri,0755)) {
	    perror("Unable to make directory.\n");
	    exit(0);
          }
	  chdir(dirri);
        } else {
	  move(22,0);
	  printw("Warning! Name already in use! Press any key to continue!");
	  refresh();
	  getch();
	  move(22,0);
	  clrtoeol();
	  refresh();
	  break;
        }
	dst = fopen(name,"w");
	if(!dst) {
 	  move(22,0);
	  printw("Sorry, couldn't store! Press any key to continue!");
	  refresh();
	  getch();
	  move(22,0);
	  clrtoeol();
	  refresh();
	  break;
        }
	fputs(nimi.nimi,dst);
	fclose(dst);
	move(22,0);
	printw("Name accepted. Press any key to continue!");
	refresh();
	getch();
	move(22,0);
	clrtoeol();
	refresh();
	break;
      case 'e':			/* Enter name. */
	sprintf(nimi.nimi,"%s",get_string(32,5,30,&i,0,nimi.nimi));
	put_name_main(&nimi);
	break;
      case 'x':
	ok = 1;			/* Exit. */
	break;
    }
  }
  return strdup(nimi.nimi);
}

